###################################################
### chunk number 1: loadLibs
###################################################
library(foreach)
# examples in this document will be executed sequentially
registerDoSEQ()


###################################################
### chunk number 2:  eval=FALSE
###################################################
## install.packages("Rmpi")


###################################################
### chunk number 3:  eval=FALSE
###################################################
## install.packages("doMPI", dependencies=TRUE)


###################################################
### chunk number 4:  eval=FALSE
###################################################
## library(doMPI)


###################################################
### chunk number 5:  eval=FALSE
###################################################
## cl <- startMPIcluster(count=2)


###################################################
### chunk number 6:  eval=FALSE
###################################################
## registerDoMPI(cl)


###################################################
### chunk number 7:  eval=FALSE
###################################################
## closeCluster(cl)


###################################################
### chunk number 8: 
###################################################
foreach(i=1:3) %dopar% sqrt(i)


###################################################
### chunk number 9: 
###################################################
x <- foreach(i=1:3) %dopar% {
    sqrt(i)
}
x


###################################################
### chunk number 10: 
###################################################
x <- foreach(i=1:3, .combine="c") %dopar% {
    sqrt(i)
}
x


###################################################
### chunk number 11: 
###################################################
x <- foreach(seed=c(7, 11, 13), .combine="cbind") %dopar% {
    set.seed(seed)
    rnorm(3)
}
x


###################################################
### chunk number 12: 
###################################################
x <- seq(-8, 8, by=0.5)
v <- foreach(y=x, .combine="cbind") %dopar% {
    r <- sqrt(x^2 + y^2) + .Machine$double.eps
    sin(r) / r
}
persp(x, x, v)


###################################################
### chunk number 13: 
###################################################
x <- seq(-8, 8, by=0.5)
sinc <- function(y) {
    r <- sqrt(x^2 + y^2) + .Machine$double.eps
    sin(r) / r
}
r <- lapply(x, sinc)
v <- do.call("cbind", r)
persp(x, x, v)


###################################################
### chunk number 14:  eval=FALSE
###################################################
## ifiles <- list.files(pattern="\\.csv$")
## ofiles <- sub("\\.csv$", ".png", ifiles)
## foreach(i=ifiles, o=ofiles, .packages="randomForest") %dopar% {
##     d <- read.csv(i)
##     rf <- randomForest(Species~., data=d, proximity=TRUE)
##     png(filename=o)
##     MDSplot(rf, d$Species)
##     dev.off()
##     NULL
## }


